﻿using System;
using System.Collections.Generic;

public partial class _Default : System.Web.UI.Page
{
    //creation of sortedlist
    static SortedList<int, string> MonthSortedList;

    /// <summary>
    /// Page load event
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        lblDisplay.Text = "";

        if (!IsPostBack)
        {
            MonthSortedList = new SortedList<int, string>();
            //add the items in sortedlist
            MonthSortedList.Add(1, "Jan");
            MonthSortedList.Add(2, "Feb");
            MonthSortedList.Add(3, "Mar");
            MonthSortedList.Add(4, "Apr");
            MonthSortedList.Add(5, "May");
            MonthSortedList.Add(6, "Jun");
        }
        RenderDetails();
    }

    /// <summary>
    /// Add items in SortedList
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnAdd_Click(object sender, EventArgs e)
    {
        int intKey;
        Int32.TryParse(txtListKey.Text, out intKey);

        if (intKey >= 0 && txtListValue.Text.Trim() != "")
        {
            if (!MonthSortedList.ContainsKey(intKey))
            {
                MonthSortedList.Add(intKey, txtListValue.Text.Trim());

                lblDisplay.Text = "SortedList Item Added";
            }
            else
            {
                lblDisplay.Text = "SortedList - Key Already Exist";
            }
        }
        else
        {
            lblDisplay.Text = "SortedList - Please Enter an Item to Add";
        }
        RenderDetails();
    }

    /// <summary>
    /// Delete items from SortedList
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDelete_Click(object sender, EventArgs e)
    {
        int intKey;
        Int32.TryParse(txtListKey.Text, out intKey);

        if (intKey >= 0)
        {
            if (MonthSortedList.ContainsKey(intKey))
            {
                MonthSortedList.Remove(intKey);

                //MonthSortedList.RemoveAt(1);
                lblDisplay.Text = "SortedList Item Deleted";
            }
            else
            {
                lblDisplay.Text = "Item Not Found.";
            }
        }
        else
        {
            lblDisplay.Text = "SortedList - Please Enter an Item to Delete";
        }
        RenderDetails();
    }

    /// <summary>
    /// Search items by Key
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnSearchbyKey_Click(object sender, EventArgs e)
    {
        int intKey;
        Int32.TryParse(txtListKey.Text, out intKey);

        if (intKey > -1)
        {
            if (MonthSortedList.ContainsKey(intKey))
            {
                lblDisplay.Text = "SortedList Item Found";
            }
            else
            {
                lblDisplay.Text = "SortedList Item Not Found.";
            }
        }
        else
        {
            lblDisplay.Text = "Please Enter an Item to Search";
        }
        RenderDetails();
    }

    /// <summary>
    /// Search Items by Value
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnSearchbyValue_Click(object sender, EventArgs e)
    {
        if (txtListValue.Text.Trim() != "")
        {
            if (MonthSortedList.ContainsValue(txtListValue.Text.Trim()))
            {
                lblDisplay.Text = "SortedList Item Found";
            }
            else
            {
                lblDisplay.Text = "SortedList Item Not Found.";
            }
        }
        else
        {
            lblDisplay.Text = "Please Enter an Item to Search";
        }
        RenderDetails();
    }

   /// <summary>
    /// SortedList Data Display
   /// </summary>
    private void RenderDetails()
    {
        lblSortedListState.Text = "";

        foreach (KeyValuePair<int, string> pair in MonthSortedList)
        {
            lblSortedListState.Text += "," + pair.Key + ":" + pair.Value;
        }
        lblSortedListState.Text = lblSortedListState.Text.TrimStart(',');
    }

    /// <summary>
    /// Other common methods of SortedList
    /// </summary>
    private void OtherFunctionality()
    {
        int intKey = 0;
        Int32.TryParse(txtListKey.Text, out intKey);

        lblDisplay.Text = " Get the index of Key: " + MonthSortedList.IndexOfKey(intKey);

        lblDisplay.Text = " Get the index of Value: " + MonthSortedList.IndexOfValue(txtListValue.Text.Trim());

        //Clear all the items of SortedList
        MonthSortedList.Clear();

        lblDisplay.Text = " Count of All the Items of SortedList: " + MonthSortedList.Count;

        lblDisplay.Text = " Capacity of All the Items of SortedList: " + MonthSortedList.Capacity;

    }


}
